<template>
  <v-col cols="12" xs="12">
    <template v-if="loading">
      <v-row justify="center" class="d-flex">
        <v-col xs="12" justify="center" class="text-center">
          <v-progress-circular
            :size="50"
            color="primary"
            indeterminate
          ></v-progress-circular>
        </v-col>
      </v-row>
    </template>
    <template v-else>
      <v-form
        id="saveUserForm"
        ref="form"
        v-model="valid"
        @submit.prevent="
          wallet
            ? walletType && walletType === 'Metamask'
              ? loginMetamask()
              : loginOtherWallet()
            : login()
        "
      >
        <v-text-field
          id="login_email"
          v-model="email"
          class="pb-4"
          :rules="rulesEmail"
          type="email"
          :label="$t('email')"
          required
          outlined
        ></v-text-field>
        <v-text-field
          v-if="wallet && wallet.startsWith('0x')"
          v-model="public_address"
          disabled
          outlined
          label="Identidad digital (Llave pública)"
          prepend-inner-icon="mdi-fingerprint"
          required
        ></v-text-field>
        <v-text-field
          v-if="!wallet"
          id="login_password"
          v-model="password"
          :append-icon="showPassword ? 'mdi-eye-off' : 'mdi-eye'"
          :type="showPassword ? 'text' : 'password'"
          class="pb-3"
          :label="$t('password')"
          :rules="rules"
          required
          outlined
          @click:append="showPassword = !showPassword"
        ></v-text-field>
        <v-col cols="12" xs="12" class="px-0">
          <v-btn
            id="save-user"
            :disabled="!valid || loading"
            :loading="loading"
            block
            type="submit"
            color="primary"
            class="white--text"
          >
            {{ $t('send') }}
          </v-btn>
        </v-col>
      </v-form>
    </template>
    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </v-col>
</template>

<script lang="ts">
import Vue from 'vue'
import { mapGetters } from 'vuex'
import LoginWalletsMixin from '@/mixins/LoginWalletsMixin'
import { getUser } from '@/services/User'
import { logIn } from '~/services/Firebase'

export default Vue.extend({
  name: 'Login',
  mixins: [LoginWalletsMixin],
  props: {
    wallet: {
      type: String,
      default: null,
    },
    walletType: {
      type: String,
      default: null,
    },
    provider: {
      type: null as any,
      default: null,
    },
  },
  data() {
    return {
      showPassword: false,
      name: '',
      last_name: '',
      email: '',
      password: '',
      valid: '',
      loading: false,
      errorMsg: Object,
      rules: [(v: string) => !!v || this.$t('campo-requerido')],
      rulesEmail: [
        (v: string) => !!v || this.$t('campo-requerido'),
        (v: string) =>
          !v ||
          /^[-\w.%+]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i.test(v) ||
          'Ingresa un email válido',
      ],
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
    }
  },
  computed: {
    public_address(): string {
      return this.wallet
    },
    web3(): any {
      return this.provider
    },
    ...mapGetters({
      user: 'users/user',
    }),
  },
  methods: {
    async login() {
      try {
        this.loading = true
        this.$emit('wait', true)
        const user = await logIn(this.$fire as any, {
          email: this.email,
          password: this.password,
        })
        await getUser(this.$fire, user.user.uid).then((res) => {
          const userCollection = res.data()

          if (
            this.$store.getters['authconfig/autenticar'] &&
            !userCollection.public_address
          ) {
            setTimeout(() => {
              this.$router.push({
                path: '/complete-data?step=3',
              })
            }, 500)
          } else if (
            this.$store.getters['authconfig/autenticar'] &&
            userCollection.public_address
          ) {
            setTimeout(() => {
              this.$router.push({
                path: '/citizen/certificates/',
              })
            }, 500)
          } else {
            setTimeout(() => {
              this.$router.push({
                path: '/',
              })
            }, 500)
          }
        })
      } catch (error) {
        let message = 'El correo o contraseña son incorrectos.'
        if (error.code === 'auth/user-disabled') {
          message = 'Usuario bloqueado.'
        }
        this.loading = false
        this.snackbar.show = true
        this.snackbar.text = message
        this.snackbar.color = 'error'
        this.$emit('wait', false)
      }
    },
    closeDialog(): any {
      this.$emit('handleDialogLogin', false)
    },
  },
})
</script>
